<template>
  <div>
    <v-row class="navQuestions my-4 mx-8" align="center" no-gutters> </v-row>
    <!-- Aluno -->
    <!-- {{ historyTest }} -->
    <br />
    <v-row
      v-if="userInfo.type == 'student'"
      no-gutters
      justify="center"
      align="center"
      class="pb-8"
    >
      <v-col cols="12" align="center"> Por favor, <b>selecione</b> a turma: </v-col>
      <v-col cols="10" sm="7" md="7" lg="5" xl="4" align="center">
        <v-select
          class="mx-3 my-4"
          dense
          v-model="selectedClass"
          label="Escolha a turma..."
          flat
          hide-no-data
          hide-details
          item-text="name"
          item-value="id"
          :items="studentClasses"
        ></v-select>
      </v-col>
    </v-row>
    <!-- Monitor -->
    <v-row
      v-if="userInfo.type == 'monitor'"
      no-gutters
      justify="center"
      align="center"
      class="pb-8"
    >
      <v-col cols="12" align="start" class="pl-12 mt-3 mb-n4">
        <b class="primary--text">Exibindo lista de provas:</b>
      </v-col>
    </v-row>
    <!-- Tabela -->
    <v-data-table
      v-if="tests.length > 0"
      class="elevation-1 px-12 pb-6"
      calculate-widths
      :headers="headers"
      :items="tests"
      :footer-props="{ itemsPerPageText: 'Provas por página' }"
    >
      <!-- Ações -->
      <template v-slot:[`item.actions`]="{ item }">
        <div class="ehqTable">
          <v-tooltip v-if="item.done" bottom color="primary">
            <template v-slot:activator="{ on }">
              <v-icon v-on="on" small @click="handleShowResult(item)">mdi-chart-bar</v-icon>
            </template>
            <span><b>Ver</b> Desempenho</span>
          </v-tooltip>

          <v-btn
            v-if="userInfo.type == 'student' && !hasHistory"
            class="my-1"
            outlined
            color="primary"
            elevation="0"
            x-small
            @click="showTest(item)"
          >
            Iniciar prova
          </v-btn>
          <v-btn
            style="pointer-events: none;"
            v-if="userInfo.type == 'student' && hasHistory"
            class="my-1"
            outlined
            color="green"
            elevation="0"
            x-small
          >
            Prova enviada
          </v-btn>
        </div>
      </template>
      <!-- Status MONITOR -->
      <template v-slot:[`item.status`]="{ item }">
        <span v-if="compareDataMethod(item.endDate) < compareData">
          <v-btn style="pointer-events: none;" class="my-1" color="primary" elevation="0" x-small>
            Já realizada
          </v-btn>
        </span>
        <span
          v-if="
            compareDataMethod(item.initialDate) < compareData &&
              compareDataMethod(item.endDate) > compareData
          "
        >
          <v-btn
            style="pointer-events: none;"
            class="my-1"
            outlined
            color="blue"
            elevation="0"
            x-small
          >
            Acontecendo
          </v-btn>
          <v-btn
            class="my-1"
            outlined
            color="primary"
            elevation="0"
            x-small
            @click="showTest(item)"
          >
            <v-icon x-small class="pr-1">mdi-eye</v-icon>Monitorar
          </v-btn>
        </span>
        <span
          v-if="
            compareDataMethod(item.initialDate) > compareData &&
              compareDataMethod(item.endDate) > compareData
          "
        >
          <v-btn
            style="pointer-events: none;"
            class="my-1"
            outlined
            color="green"
            elevation="0"
            x-small
          >
            À realizar
          </v-btn>
        </span>
      </template>
      <!-- Questões -->
      <template v-slot:[`item.questions`]="{ item }">
        {{ item.questions.length }}
      </template>
      <!-- Disciplina -->
      <template v-slot:[`item.class`]="{ item }">
        {{ item.class.name }} {{ item.class.surname }}
      </template>
      <!-- Data -->
      <template v-slot:[`item.initialDate`]="{ item }">
        <span v-html="convertData(item.initialDate)" />
      </template>
      <template v-slot:[`item.endDate`]="{ item }">
        <span v-html="convertData(item.endDate)" />
      </template>
    </v-data-table>

    <v-row
      v-if="userInfo.type == 'monitor' && tests.length == 0"
      no-gutters
      justify="center"
      class="pb-8"
    >
      <span>Ops, parece que você ainda <b>não</b> tem nenhuma prova para monitorar :(</span>
    </v-row>

    <v-row
      v-if="userInfo.type == 'student' && selectedClass && tests.length == 0"
      no-gutters
      justify="center"
      class="pb-8"
    >
      <span>Ops, parece que você <b>não</b> tem nenhuma prova agendada nessa matéria :)</span>
    </v-row>

    <!-- INICIO DOS DIALOGS -->

    <v-dialog v-if="dialogShowTest" v-model="dialogShowTest" color="white" fullscreen persistent>
      <ShowTest
        ref="refShow"
        :initialDate="selectedTestInitialDate"
        :endDate="selectedTestEndDate"
        :dialogShowTest="dialogShowTest"
        :test="testToView"
        :userRole="userRole"
        :onlyView="onlyView"
        @handleClose="closeTest"
      />
    </v-dialog>
    <v-dialog v-model="dialogShowPerformance" color="white" fullscreen persistent>
      <ShowResult
        ref="refPerformance"
        :test="testToView"
        :userRole="userRole"
        @handleClose="closeResultTest"
      />
    </v-dialog>
  </div>
</template>

<script>
import ShowTest from './ShowTest.vue'
import ShowResult from './ShowResult.vue'
import Monitor from '../../../servicesEhq/req/monitor'
import Student from '../../../servicesEhq/req/student'
import { Utils } from '../../../utils/utils'

export default {
  name: 'MainTeacher',

  props: {
    userRole: { type: String, default: '' },
  },

  computed: {},

  components: { ShowTest, ShowResult },

  data: () => ({
    headers: [],
    headersStudent: [
      { text: 'Título', align: 'center', sortable: false, value: 'title', width: '18%' },
      { text: 'Instruções', align: 'center', sortable: false, value: 'instructions', width: '35%' },
      { text: 'Data Início', align: 'center', sortable: false, value: 'initialDate', width: '15%' },
      { text: 'Data Fim', align: 'center', sortable: false, value: 'endDate', width: '15%' },
      { text: 'Ações', align: 'center', sortable: false, value: 'actions', width: '17%' },
    ],
    headersMonitor: [
      { text: 'Título', align: 'center', sortable: false, value: 'title', width: '18%' },
      { text: 'Instruções', align: 'center', sortable: false, value: 'instructions', width: '38%' },
      { text: 'Data Início', align: 'center', sortable: false, value: 'initialDate', width: '17%' },
      { text: 'Data Fim', align: 'center', sortable: false, value: 'endDate', width: '17%' },
      { text: 'Status', align: 'center', sortable: false, value: 'status', width: '10%' },
    ],
    //tipo de questões: summation, multipleChoice, objective, trueOrFalse, dissertation
    tests: [],
    studentClasses: [],
    selectedClass: '',
    itemToView: {},
    testToView: {},
    onlyView: false,
    dialogShowTest: false,
    dialogShowPerformance: false,
    userInfo: {},
    monitoring: '',
    compareData: '',
    hasHistory: false,
    selectedTestInitialDate: '',
    selectedTestEndDate: '',
  }),

  async created() {
    this.generateData()
    this.userInfo = await this.$getItem('userEHQ')

    if (this.userInfo.type == 'monitor') {
      this.headers = this.headersMonitor

      await this.monitorReadTests(this.userInfo.id)
      await this.enterTestMonitoring(this.userInfo.id)
    }

    if (this.userInfo.type == 'student') {
      this.headers = this.headersStudent
      await this.studentReadClasses(this.userInfo.id)
    }
  },

  async beforeCreate() {},

  watch: {
    async selectedClass() {
      await this.loadTest(this.selectedClass, this.userInfo.id)
      await this.checkAlreadySendTest()
    },
  },

  methods: {
    // FRONTEND BÁSICO
    generateData() {
      let actualData = new Date()
      actualData.getTime()
      this.compareData = actualData
    },

    compareDataMethod(item) {
      let newData = new Date(item)
      let convert = newData.getTime()
      return convert
    },

    async checkAlreadySendTest() {
      try {
        let history = await this.$getItem('ehqTest')
        let check = false

        this.tests.forEach((test) => {
          if (test.id == history.test.test) check = true
        })

        if (history && history.test.student == this.userInfo.id && check) {
          this.hasHistory = true
        }
      } catch (e) {
        this.hasHistory = false
      }
    },

    //ver prova para resolver
    async showTest(item) {
      this.selectedTestInitialDate = item.initialDate
      this.selectedTestEndDate = item.endDate

      if (this.userInfo.type == 'student') await this.initTest(item.id)
      if (this.userInfo.type == 'monitor') {
        this.dialogShowTest = true
        let question = { ...item, questions: [] }
        this.testToView = question
      }
    },

    async closeTest() {
      this.dialogShowTest = false
      this.onlyView = false
      this.testToView = { id: '', questions: [] }
      if (this.userInfo.type == 'student') await this.checkAlreadySendTest()
    },

    //ver resultado da prova
    handleShowResult(item) {
      this.dialogShowPerformance = true
      this.testToView = item
    },

    closeResultTest() {
      this.dialogShowPerformance = false
      this.testToView = { id: '', questions: [] }
    },

    convertData(data) {
      let newData = new Date(data)
      let convert = newData.getTime()
      return Utils.compareDate(convert)
    },

    // INTEGRAÇÃO BACKEND

    //monitor

    async monitorReadTests(monitorId) {
      try {
        let req = await Monitor.readTests(monitorId)
        if (req.success) {
          this.tests = req.data
        }
      } catch (e) {
        console.log(e)
      } finally {
      }
    },

    async enterTestMonitoring(monitorId) {
      try {
        let req = await Monitor.enterTestMonitoring(monitorId)
        if (req.success) {
          this.monitoring = req.data
        }
      } catch (e) {
        console.log(e)
      } finally {
      }
    },

    //aluno

    async studentReadClasses(studentId) {
      try {
        let req = await Student.getClasses(studentId)
        if (req.success) {
          this.studentClasses = req.data
        }
      } catch (e) {
        console.log(e)
      } finally {
      }
    },

    async loadTest(classId, studentId) {
      let data = { classId: classId, studentId: studentId }
      try {
        let req = await Student.enterTest(data)
        if (req.success) {
          this.tests = [req.data]
        }
      } catch (e) {
        console.log(e)
      } finally {
      }
    },

    async initTest(testId) {
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let req = await Student.runTest(this.userInfo.id, testId)
        if (req.success) {
          this.dialogShowTest = true
          this.testToView = req.data
          this.testToView = Object.assign(this.testToView, {
            title: this.tests[0].title,
            instructions: this.tests[0].instructions,
          })
        } else {
          if (req.data.description == "We didn't find an answer to error waitTest on model area") {
            this.$store.commit('user/UPDATE_ALERT', {
              status: true,
              message: `Aguarde o horário informado, a prova ainda <b>não</b> começou.`,
              icon: 'mdi-alert',
              color: 'test',
            })
          }
        }
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },
  },
}
</script>

<style>
.viewQuestionStyle:hover {
  font-weight: 600;
  cursor: pointer;
}
</style>
